/*----------------------------------------------------------------------------

  NLHDR - Non local high dynamic range image generation

  Copyright (c) 2013 cecilia aguerrebere <caguerrebere@gmail.com>
   
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU Affero General Public License as
  published by the Free Software Foundation, either version 3 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU Affero General Public License for more details.

  This code is partially based on the implementation by A. Buades
  
  A. Buades, B. Coll, and J.-M. Morel. Non-Local Means Denoising. 
  Image Processing On Line, 2011

 ----------------------------------------------------------------------------*/
  

#ifndef _NLHDR_H_
#define _NLHDR_H_


#include "libauxiliar.h"


void   nlhdr  (int iDWin,       /* Half patch size */
		      int iDBloc,		/* Half size of research window */
		      float ***fpI,		/* Input images */
		      float **fpO,		/* Output image */
		      int iFrames,      /* Number of input frames */
		      int iChannels,    /* Number of input image channels */ 
		      int iWidth,       /* Number of columns of input images */
		      int iHeight,      /* Number of rows of input images */
		      float* tau,       /* Exposure times vector */
		      int ref_t,        /* Reference frame index */
		      float ih,         /* Threshold on patch distances */
		      int* trans_y,     /* Vector of vertical (row) translations of each frame with respect to the reference frame*/
		      int* trans_x,     /* Vector of horizontal (column) translations of each frame with respect to the reference frame*/
		      float muR,        /* Camera parameters: readout noise mean */
		      float sigma2R,    /*                    readout noise variance */
		      float *g,         /*                    gain */
		      float **prnu,     /*                    PRNU factors map */
		      float iVsat);     /*                    saturation threshold */



#endif
